@echo off
if "%OS%" == "Windows_NT" setlocal

rem 
rem  dbsetup.bat <-debug>
rem 
rem  Use -debug option to display sql being executed.
rem 

if "%JOBSERVER_HOME%" == "" goto guessIt
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
set dumby=""
rem Even though it is set and not correct try to guess
:guessIt
set JOBSERVER_HOME=.
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
rem Try to guess what JOBSERVER_HOME is
set JOBSERVER_HOME=..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
set JOBSERVER_HOME=..\..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
echo  The JOBSERVER_HOME environment variable is not set. This
echo  variable needs to be set to run this program. Program
echo  exiting.
goto  end

:okHome
if exist "%JAVA_HOME%\bin\java.exe" goto okExec
echo  The JAVA_HOME environment variable is not set. This
echo  variable needs to be set to run this program. Program
echo  exiting.
goto  end

:okExec
set JS_DB_TOOL_DEBUG=false
if not "%1" == "-debug" goto okDoneargs
set JS_DB_TOOL_DEBUG=true

:okDoneargs
set DB_SCHEMA_NAME=no_schema

echo.
echo  Select database type to setup (mysql, oracle, postgre)
set /P DB_TYPE=

if "%DB_TYPE%" == "postgre" goto step2
set dumby=""
if "%DB_TYPE%" == "oracle" goto step3
set dumby=""
if "%DB_TYPE%" == "mysql" goto step3
     echo.
     echo    Error: database type must be (mysql, oracle, postgre)
     echo.
     goto end


rem postgre step only
:step2
echo.
echo  You may optionally specify a schema namespace for your JobServer database.
echo  The tables will be assigned to the schema namespace given here. Make"
echo  sure to have your database administrator create the schema namespace before
echo  you proceed here. Leave blank if no schema namespace is desired.
echo    Enter database schema namespace )
set /P DB_SCHEMA_NAME=

if NOT "%DB_SCHEMA_NAME%" == "" goto step3
set DB_SCHEMA_NAME=no_schema

:step3
echo.
echo  Enter database hostname )
set /P DB_HOST=
if NOT "%DB_HOST%" == "" goto step4
echo.
echo    Error: You must provide a database hostname
echo.
goto end
 
:step4
echo.
echo  Enter database name )
set /P DB_NAME=
if NOT "%DB_NAME%" == "" goto step5
echo.
echo   Error: You must provide a database name
echo.
goto end

:step5
echo.
echo  Enter database port number )
set /P DB_PORT=
if NOT "%DB_PORT%" == "" goto step6
echo.
echo   Error: You must provide a database port number
echo.
goto end

:step6
echo.
if "%DB_TYPE%" == "postgre" (
 echo  Enter database administrator's username. This user will own the
 echo  JobServer tables and will need to have adequate rights to create
 echo  the JobServer tables and indexes.
) ELSE (
 echo  Enter database administrator's username. This user will need to
 echo  have adequate rights to create the JobServer tables and indexes.
)
echo     Enter database administrator's username )
set /P DB_USER=
if NOT "%DB_USER%" == "" goto step7
echo.
echo   Error: You must provide a database username here
echo.
goto end

:step7
echo.
echo  Enter database administrator's password )
set /P DB_PASS=
if NOT "%DB_PASS%" == "" goto step8
echo.
echo   Error: You must provide a database password
echo.
goto end

:step8
echo.
echo  Enter database username to be used by JobServer applications. We recommend
echo  using the name "jsuser", but you can use any other valid db user. Normally,
echo  this user is NOT the same user as the database administrative user
echo  requested above, but can be the same user if necessary. This user will be
echo  granted rights to SELECT/UPDATE/INSERT/DELETE for the JobServer tables
echo  about to be created here. If you leave this blank, it defaults to the
echo  administrative user entered above.
echo     Enter application database username )
set /P DB_JS_USERNAME=
if NOT "%DB_JS_USERNAME%" == "" goto step9
set DB_JS_USERNAME=%DB_USER%


:step9

rem echo %DB_TYPE% 
rem echo %DB_SCHEMA_NAME% 
rem echo %DB_HOST% 
rem echo %DB_PORT% 
rem echo %DB_USER% 
rem echo %DB_PASS%  
rem echo %DB_NAME% 
rem echo %DB_JS_USERNAME%
rem goto end

echo.
echo  Preparing to connect to remote database to create new JobServer database...........
echo.

call "%JOBSERVER_HOME%\bin\toolbin\initializedb" %DB_TYPE% %DB_SCHEMA_NAME% %DB_HOST% %DB_PORT% %DB_USER% %DB_PASS% %DB_NAME% %DB_JS_USERNAME%

echo.
:end
pause
