@echo off
if "%OS%" == "Windows_NT" setlocal

rem Shuts down the JobServer Enviironment

set NOPAUSE=true
if "%1" == "-nopause" goto letsgo
set NOPAUSE=false

:letsgo
if "%JOBSERVER_HOME%" == "" goto guessIt
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
set dumby=""
rem Even though it is set and not correct try to guess
:guessIt
set JOBSERVER_HOME=.
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
rem Try to guess what JOBSERVER_HOME is
set JOBSERVER_HOME=..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
set JOBSERVER_HOME=..\..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
echo  The JOBSERVER_HOME environment variable is not set. This
echo  variable needs to be set to run this program. Program
echo  exiting.
goto  end

:okHome
call "%JOBSERVER_HOME%\conf\system-config.bat"

for /F "usebackq" %%i IN (`hostname`) DO set jshost=%%i
set JS_SERVER_HOSTNAME=%jshost%
if "%JOBSERVER_HOSTNAME%" == "" goto stepLocalhost
set JS_SERVER_HOSTNAME=%JOBSERVER_HOSTNAME%
:stepLocalhost

IF NOT EXIST "%JOBSERVER_HOME%\EJS-DATA\startup-log\%JS_SERVER_HOSTNAME%\winservice.lck" GOTO skipStep
del "%JOBSERVER_HOME%\EJS-DATA\startup-log\%JS_SERVER_HOSTNAME%\winservice.lck"
:skipStep

if exist "%JAVA_HOME%\bin\java.exe" goto okExec
echo  The JAVA_HOME environment variable is not set. This
echo  variable needs to be set to run this program. Program
echo  exiting.
goto  end

:okExec
echo.
echo  Preparing to Shutdown JobServer Environment................

call "%JOBSERVER_HOME%\bin\jsmonitor" -simplewsprestopwebservercall > nul

call "%JOBSERVER_HOME%\bin\toolbin\stopweb.bat"

if "webletModeOnly" == "true" goto agentskip
if "%dbHost%" == "" goto :agentskip
if "%agentPort%" == "" goto :agentskip
call "%JOBSERVER_HOME%\bin\jsmonitor" -killagent > nul
set ENVCHECK=%ERRORLEVEL%
if "%ENVCHECK%" == "0" (
    echo  Agent Container Shutdown
) else (
    echo  Agent Container - Already Shutdown
)
:agentskip

if "webletModeOnly" == "true" goto skipJS
if "%dbHost%" == "" goto startJS
if "%primarySchedServer%" == "" goto startJS
if "%primarySchedServer%" == "%JS_SERVER_HOSTNAME%" goto startJS
if "%secondarySchedServer%" == "%JS_SERVER_HOSTNAME%" goto startJS
goto skipJS
:startJS
call "%JOBSERVER_HOME%\bin\jsmonitor" -killcontainer > nul
set ENVCHECK=%ERRORLEVEL%
if "%ENVCHECK%" == "1" (
    echo  JobServer Container - Already Shutdown
) else (
    echo  JobServer Container Shutdown
)
:skipJS

if NOT "%dbHost%" == "" goto skipDB
call "%JOBSERVER_HOME%\bin\toolbin\stopdb.bat"
:skipDB

rem IF NOT EXIST "%JOBSERVER_HOME%\EJS-DATA\startup-log\%JS_SERVER_HOSTNAME%\winservice.lck" GOTO skipStep
rem del "%JOBSERVER_HOME%\EJS-DATA\startup-log\%JS_SERVER_HOSTNAME%\winservice.lck"
rem :skipStep

echo  ..........JobServer Environment Shutdown Complete
echo.

:end

if "%NOPAUSE%" == "true" goto realEnd
pause

:realEnd

